# developer Analytics - Full Documentation # abs({n}) Returns the absolute number of _n_ as a numeric value. _n_ can be any real numeric value in the range of -1.797e308 \<= _n_ \<= 1.797e308. `abs({n})` takes the following syntax. ```nolang SELECT abs(COLUMN_NAME) as ALIASNAME FROM DATASET; ``` ## Example This example takes the absolute value of the Profit field. ```nolang SELECT abs(Profit) as absProfit FROM Superstore LIMIT 1; ``` | absProfit | | --------- | | 41.9136 | # abs(n) Returns the absolute number of _n_ as a numeric value. _n_ can be any real numeric value in the range of -1e308 \<= _n_ \<= 1e308. This function can only be used in a `foreach` statement. ## Example ```nolang q = foreach q generate abs(pct_change) as pct_magnitude; ``` # Access Apex Examples Examples include checking the Integration User access inside your WaveTemplateConfigurationModifier implementation. ## Example **In the `onConfigurationRetrival` implementation, verify the Integration User access to the Account sObject. Add the access result to the template variables.** ```nolang public class ExampleWaveTemplateConfigurationModifier extends wavetemplate.WaveTemplateConfigurationModifier { public override void onConfigurationRetrieval(wavetemplate.WaveTemplateInfo waveTemplate) { String accessResult = null; if (!wavetemplate.Access.integUserHasAccessToSObjectField('Account', 'Industry')) { accessResult = 'No Access'; } else { accessResult = 'Access found'; } template.getVariables().get('accountAccess').setComputedValue(accsssResult); } } ``` ## Example **In the `onConfigurationRetrival` implementation, verify the Integration User has access more than 100 records in the Account sObject. Add the result to the template variables.** ```nolang public class ExampleWaveTemplateConfigurationModifier extends wavetemplate.WaveTemplateConfigurationModifier { public override void onConfigurationRetrieval(wavetemplate.WaveTemplateInfo waveTemplate) { Boolean enoughAcctRecords = true; if (!wavetemplate.Access.getCountOfRecordsAsIntegUser('Account') > 100) { enoughAcctRecords = false; } template.getVariables().get('sufficientAcctRecordsFound').setComputedValue(enoughAcctRecords); } } ``` ## Example **Before creating the app, verify Integration User access to an sObject field selected during template wizard processing:** ```nolang public class ExampleWaveTemplateConfigurationModifier extends wavetemplate.WaveTemplateConfigurationModifier { public override void beforeAppCreate(wavetemplate.WaveTemplateInfo waveTemplate, String previousAppVersion, wavetemplate.Answers answers) { Boolean access = wavetemplate.Access.integUserHasAccessToSObjectField('sObjectFieldExample', template, answers); if (!access) { throw new wavetemplate.TemplateInterruptException('Integ User doesn't have access to sObjectFieldExample'); } } } ``` ## Example **Before creating the app, verify if there are any sObject fields the Integration User doesn't have access from an array of fields selected during template wizard processing:** ```nolang public class ExampleWaveTemplateConfigurationModifier extends wavetemplate.WaveTemplateConfigurationModifier { public override void beforeAppCreate(wavetemplate.WaveTemplateInfo waveTemplate, String previousAppVersion, wavetemplate.Answers answers) { List noAccessFields = wavetemplate.Access.checkIntegUserAccessToArrayOfSObjectFields('sobjectFieldArray', template, answers); if (!noAccessFields.isEmpty()) { throw new wavetemplate.TemplateInterruptException('Integ User doesn't have access to ' + noAccessFields.get(0)); } } } ``` # Access Data 360 XMD in the UI Open a lens view from the dashboard to rename columns, rename values, or apply custom colors to a Data 360 object. Datasets support two entry points for editing XMD: opening the dataset directly from the Browse or Recents page as a lens, or exploring a dashboard widget. Data 360 objects support only dashboard and widget entry points. You can't open them as lenses from the Browse page. 1. Open a dashboard widget backed by a Data 360 query in preview mode. 2. Select **Explore** from the dropdown menu to open as a lens. 3. Open the **Fields Panel**. 4. Use the column dropdown menu to rename columns, rename values, or apply custom colors. # Access Date Functions with Time Zone Enabled Use these functions to get the day, week, year, and other parts of `DateTime` or `DateOnly` fields. The return values are numbers. To enable Time Zone for your org, follow the directions in [Enable Custom Time Zones](https://help.salesforce.com/s/articleView?id=analytics.bi_setup_time_zone_support.htm&type=5). For the allowed formats, see [Date Formats](https://developer.salesforce.com/docs/analytics/bi-dev-guide-saql/reference/bi-date-formats.md). - `year (DateTime | DateOnly)` - `quarter (DateTime | DateOnly)` - `month (DateTime | DateOnly)` - `week (DateTime | DateOnly)` - `day (DateTime | DateOnly)` - `hour (DateTime)` - `minute (DateTime)` - `second (DateTime)` - `fiscalYear (DateTime | DateOnly)` - `fiscalQuarter (DateTime | DateOnly)` - `fiscalMonth (DateTime | DateOnly)` - `fiscalWeek (DateTime | DateOnly)` - `epochDay (DateTime | DateOnly)` - `epochSecond( DateTime | DateOnly)` ## Examples Use `year()`, `month()`, and `day()` to project the year, month, and day for each record. `CloseDate` can be a `DateTime` or `DateOnly` type. ```nolang q = foreach q generate year('CloseDate') as "Year", month('CloseDate') as "Month", day('CloseDate') as "Day"; ``` Use `month()` to find results that closed in December. ```nolang q = filter q by month('CloseDate') == 12; ``` Use `month()` to order opportunities by month of close date. ```nolang q = order q by month('CloseDate'); ``` For even more granularity, add `hour()`, `minute()`, and `second()` to project the time for each record. These functions can only be used with a `DateTime` type. ```nolang q = foreach q generate year('CloseDate') as "Year", month('CloseDate') as "Month", day('CloseDate') as "Day", hour('CloseDate') as "Hour", minute('CloseDate') as "Minute", second('CloseDate') as "Second"; ``` Use `hour()` to order opportunities by hour of close date. ```nolang q = order q by hour('CloseDate'); ``` # Access Methods Use the `Access` features with the following methods. - `checkIntegUserAccessToArrayOfSObjectFields`. Checks an array of sObjectFields from a template answer and returns a list of fields the Integration User doesn't have access to. Requires the variable name, `WaveTemplateInfo`, and `Answers`: ```nolang global static List checkIntegUserAccessToArrayOfSObjectFields(String variableName, wavetemplate.WaveTemplateInfo template, wavetemplate.Answers answers) ``` - `getCountOfRecordsAsIntegUser`. Returns the number of records visible to the Integration User. Use this method to gauge if the number of records is high enough to continue with template processing. There’s a limit of 10K rows. Requires the sObject name to use for the count: ```nolang global static Integer getCountOfRecordsAsIntegUser(String sObjectName) ``` - `integUserHasAccessToSObjectField`. Checks an sObjectField answer to verify that the Integration User has access to it. Requires the variable name, `WaveTemplateInfo`, and `Answers`: ```nolang global static boolean integUserHasAccesstoSObjectField(String variableName, wavetemplate.WaveTemplateInfo template, wavetemplate.Answers answers) ``` - `integUserHasAccessToSObjectField`. Checks a single sObject and one of its fields to verify that the Integration User has access to it. Requires the sObject name and `WaveTemplateInfo`: ```nolang global static boolean integUserHasAccessToSObjectField(String sObjectName, wavetemplate.WaveTemplateInfo template) ``` # Access Parts of a Date Use the `EXTRACT()` function to access parts of a date. You can use `EXTRACT()` in projections, filtering, grouping and ordering. `EXTRACT()` follows this syntax. ```nolang EXTRACT(DATE_PART FROM DATE_FIELD) ``` A date part can be one of the following values. - `YEAR` - `QUARTER` - `MONTH` - `WEEK` - `DAY` - `HOUR` - `MINUTE` - `SECOND` - `EPOCH_DAY` - `EPOCH` - `FISCAL_YEAR` - `FISCAL_QUARTER` - `FISCAL_MONTH` - `FISCAL_WEEK` **note:** If you query a date field that doesn't contain time information, it will return 0. # acos({n}) Returns the arccosine value of radians value `{n}`. `{n}` can be any real number in the range of -1 \<= `{n}` \<= 1. If `null` is passed as an argument, `acos()` returns `null`. `acos({n})` takes the following syntax. ```nolang SELECT ACOS(N) as ALIAS FROM DATASET; ``` ## Example This example takes the arccosine of 35 degrees. ```nolang SELECT ACOS(RADIANS(90)) as acosValue FROM "Opportunity" LIMIT 1; ``` | acosValue | | --------- | | 0.913643 | # acos(n) Returns the arccosine value of radians value _n_. _n_ can be any real numeric value in the range of -1 \<= _n_ \<= 1. If `null` is passed as an argument, `acos()` returns `null`. This function can only be used in a `foreach` statement. ## Example ```nolang q = foreach q generate acos(radians) as arccosine; ``` # Actions in Rules Actions define what a rule does. Use constants to make it easier to perform any action. ## Actions Actions define the way rules change an app’s JSON files. Valid actions are: - `delete`: Delete a node in the document. - `put`: Add a node to an object. - `set`: Set the value of an existing node in the document. - `add`: Add an element to an array - `eval`: Evaluate a specified expression and assign results to a variable. - `replace`: Search and replace a text string globally. Each action has a path attribute, which is a [JsonPath](http://goessner.net/articles/JsonPath/) that points to a node in the document. JsonPath is to JSON as XPath is to XML. Practice it in the [Jayway JsonPath Evaluator](http://jsonpath.herokuapp.com). **note:** If a template is updated to change the `assetVersion`, it can impact the JsonPath. Always test the rules for app creation after a template update. Actions can be conditionally applied to a document. Set the condition on a set of actions or on a collection of actions. # Actions Syntax for Rules | Action | Example | Notes | | --------- | ------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------ | | `add` |   | Adds an entry to an existing array. Needs `"index"` and `"value"`. `"index"` should be 0 for the first element in the array, any number after that for the middle of the array. If `"index"` is larger than the array size, the value is added to the end of the array. | | `put` |   | Add an attribute and value to an existing JSON value. Needs `"key"` and `"value"`. `"value"` can be a string or an array. | | `set` |   | Set a value on an existing JSON attribute. Needs `"value"`. | | `delete` |   | Remove a node in the existing JSON tree. | | `eval` |   | Evaluate the expression specified in `'value'` and assign results to the context variable specified by `'key'` (if set). Context attribute can be referenced using the expression: `${Rules.Eval.}`. The scope of the eval variable is the entire document if performed in a rule, or the macro if performed within a macro. | | `replace` |   | Replace any text string throughout the entire document. Use when regular expressions are not an option. Can still use expressions. Instead of using the `'replace'` action, you can perform targeted search and replace (JSON Path) with `${string:replace(...)}`. In cases requiring regular expressions, use `${string:replaceFirst(...)}, ${string:replaceAll(...)}`. | Example `add` action: ```nolang { "action": "add", "description" : "Add desc", "path": "$.json.path.to.existing.json,array", "index": 0, "value": "value to add" } ``` Example `put` action: ```nolang { "action": "put", "description" : "Put desc", "path": "$.json.path.to.existing.json", "key": "jsonAttributeName", "value": "new value" } ``` Example `set` action: ```nolang { "action": "set", "description" : "Set desc", "path": "$.json.path.to.attribute", "value": "setValue" } ``` Example `delete` action: ```nolang { "action": "delete", "description" : "Delete desc", "path": "$.json.path.to.delete" } ``` Example `eval` action: ```nolang [ { "action": "eval", "key": "helloResult", "value": "${myMacros:sayHello('Hello')}" }, { "action": "set", "path": "$.path.json.node", "value": "${Rules.Eval.helloResult}" }] ``` Example `replace` action: ```nolang { "action": "replace", "key": "RPLCM_Opportunity_Amount_Field", "value": "${Variables.Opportunity_Amount.fieldName}" }, ``` # Add a Recipe to a CRM Analytics Template Data prep recipes are a unique CRM Analytics asset, as they aren’t stored in folders like dashboards, lenses, and datasets. The only way to connect a recipe to an app is via the relationship of the datasets in the folder to the recipes that consume or output those datasets. When a recipe creates a dataset for a CRM Analytics app, the dataset connects the recipe to the folder ID for the app. These recipes are automatically added to the app template when it’s created from the app. Only recipes that run successfully and create a dataset are added to the app template. If a recipe doesn’t contain a dataset, like a recipe that reads and writes from a connector, there’s no way for the app framework to determine which app the recipe belongs to. To solve this issue, in v55.0 and above, the Connect REST API for creating and updating a template supports a list of recipe IDs in the request. **note:** Only the REST APIs and the Analytics CLI support creation with recipe IDs. Users can’t specify recipe IDs when creating a template from an app in Analytics Studio. When the app framework adds recipes to a template, it doesn’t know the order in which the recipes must be run. On template creation, the app framework first adds any recipes specified in the request. Then the framework finds recipes used to create datasets for this app and adds them to the end of the list. If a duplicate recipe ID is specified, the app framework ignores it. During app creation, the recipes are run in the order in which they’re defined in the `template-info.json` file. If the recipes must run in specific order, you must edit the `template-info.json` file manually to put the recipes in run order. ## Example Use the Connect REST API Use the template REST API to create a template from an app and include 2 recipes. In the POST request body, use the `recipeIds` parameter to specify any additional recipes to add to the app template. ```nolang POST /wave/templates/ { "folderSource": { "id": "00lxx000000xxxxxx" }, "name": "myAppTemplate", "label": "My App Template", "description": "My app template with recipes", "recipeIds": [ "05vxx000000xxxxx1", "05vxx000000xxxxx2" ] } ``` When updating an existing template to add recipes, specify the `recipeIds` in the PUT request body. ```nolang PUT /wave/templates/0Nk1k000000xxxxxx { "folderSource": { "id": "00lxx000000xxxxxx" }, "recipeIds": [ "05vxx000000xxxxx3" ] } ``` This request adds another recipe to the existing template. If the recipe exists in the template, the PUT request does a no-op. **note:** The PUT only adds recipes to an existing template. If you need to remove a recipe, you must download the template and modify the `template-info.json` file manually. ## Example Use the Analytics CLI Plugin First, get a list of recipes in your org: ```nolang sf analytics recipe list ``` returning: ```nolang RECIPEID NAME NAMESPACE LABEL STATUS _________________ _____________ __________________ ______________ _______ 05vxx000000xxxxx1 Recipe_One Recipe One New 05vxx000000xxxxx2 Recipe_Two Recipe Two New ``` Then, create a template from an app and include the recipe IDs: ```nolang sf analytics template create -f 00lxx000000xxxxxx -l "My App Template" -r "05vxx000000xxxxx1, 05vxx000000xxxxx2" ``` **note:** When specifying multiple recipe IDs, they must be enclosed in quotes. To add a recipe to an existing template: ```nolang sf analytics template update -t 0Nk1k000000xxxxxx -f 00lxx000000xxxxxx -r 05vxx000000xxxxx3 ``` # Add a Remote Connector to a CRM Analytics Template Add remote connectors to the digest node of a template dataflow by referencing connectors in `variables.json` and editing `ui.json` and `rules.json`. ## Using the ConnectorType Variable in variables.json If your app includes a connection to a remote data source, add the connection to the template using a `ConnectorType` variable to `variables.json`. `ConnectorType` is a variation of the `StringType` variable with an added `connectorType` attribute. The attribute lets you specify types of connectors to add to the template dataflow, as follows: ```nolang "ExternalConnector" : { "label" : "my connector", "description" : "This will be the connector.", "variableType" : { "type" : "ConnectorType", "connectorType" : "SalesforceExternal” }, "required" : true } ``` The `connectorType` attribute must be a string. It corresponds to values in `WaveDataConnectorTypeEnum`. The value is a “starts with” instead of an “equals,” so using Salesforce includes any connector beginning with that string, such as `SalesforceExternal`, `SalesforceMarketingCloud`, and `SalesforceMarketingCloudOAuth2`. Leave the `connectorType` value blank to include all defined connectors in the org. You can also use a `ConnectorType` variable as the `itemType` in an `ArrayType` variable. After using the `ConnectorType` variable in `variables.json`, add the variable to `ui.json` so a user creating an app can choose connectors in the template wizard. The user’s org must have at least one connector of the specified type already authenticated, but that connector doesn’t need existing replicated objects. The wizard displays all remote connectors that match the `connectorType` attribute’s criteria, as shown here. ![An app creation wizard page showing connector selections](https://developer.salesforce.com/media/bi_dev_guide_wave_templates/bi_templatesdev_connector_types_in_wizard.png) ## Add a Rule to Replace the connectionName in the Dataflow Use the `ConnectorType` variable in a rule to update the dataflow's digest node `connectionName` at app creation time. Here’s an example rule: ```nolang { "rules" : [ { "name" : "UpdateConnectors", "appliesTo" : [ { "type" : "workflow", "name" : "*" }], "actions" : [ { "action" : "set", "description" : "Use connector for digest node", "path" : "$..workflowDefinition.digest_Account.parameters.connectionName", "value" : "${Variables.ExternalConnector}" }] }] } ``` Avoid using `${Variables.ExternalConnector}` directly in the template workflow JSON. Every time the template is updated from the source app, this variable token is overwritten and removed. # Add a Tableau Next Component to Your Web App ## Embed the Tableau Next Component Copy the generated Tableau Next component code you copied from Tableau Next into your web app. This required code includes - A container for the component: use the container for component sizing and responsiveness - The SDK configuration: this defines the auth credential and the Salesforce org URL - The import of the SDK: integrates the SDK into the web app - The `initializeAnalyticsSdk` call: initializes the SDK with the configuration. - The Tableau Next component constructor: creates the Tableau Next component, using the ID or API name. Each component provides programmatic interactivity, like event handling and data filtering. - `AnalyticsDashboard`: embeds a Tableau Next dashboard - `AnalyticsMetric`: embeds a Tableau Next metric - `AnalyticsVisualization`: embeds a Tableau Next visualization - The component `render` call: renders the component in the container ### Generated Code Example for an AnalyticDashboard component ```html
``` ## Hook the Tableau Next Component To Your Web App After you copy the generated code, you need to replace the generalized values with values specific to your web app. The `AUTH_CREDENTIAL` value is the generated Frontdoor URL. The `SDK_SOURCE` value is the location of the installed SDK for your web app. If you don't use the generated code snippet from Tableau Next, you must add the `orgUrl` value, pointing to your Salesforce org. The `orgUrl` must be the Lightning URL, `https://yourorg.lightning.force.com`, not the `my.salesforce.com` domain URL. If you don't use the generated code snippet from Tableau Next, you'll need to add the `orgUrl`, pointing to your Salesforce org. ## Finding the Component ID For embedding, you need the component ID. If you use the generated component code snippet, the component ID is provided for you. You can also find the ID using the component URL from Salesforce. In Tableau Next, view the asset you want to embed. When viewing the asset, the URL for the asset provides the asset API name. **Example: Dashboard URL** `https://.force.com/tableau/dashboard//view`. **Example: Visualization URL** `https://.force.com/tableau/visualization//view`. **Example: Metric URL** `https://.force.com/tableau/exploreMetric/?{metricParameters}`. The `asset-api-name` is used for embedding as the `idOrApiName` value in the component constructor. You can use the component API name or the ID. For an example of loading a custom view for dashboard, see [Embed a Custom Dashboard View](/docs/analytics/sdk/guide/sdk-use-cases.html#embed_a_custom_dashboard_view). ## Authentication Redirect Flows In multiple org scenarios, each org can complete initialization with a different outcome. In a single org scenarios, the same redirect handling applies for the single org. If an org requires additional authentication, like a multi-factor authentication (MFA) challenge or password reset, the `initializeAnalyticSdk` method can return a non-success state for that org with redirect metadata in `orgStates`: - `state`: `AUTH_REDIRECT` - `redirectUrl`: org provided relative redirect path - `redirectOrigin`: org provided origin For each org in `AUTH_REDIRECT`, open `${redirectOrigin}${redirectUrl}` in a popup window or tab, and complete the required authentication step. Then call `retryOrAddOrgs()` for the affected org(s) to resume initialization. Retry parameter patterns: - Standard retry: use a fresh Frontdoor URL/session credential `{ orgUrl, authCredential: "" }` - MFA or password-reset resumed session: use the org URL as credential `{ orgUrl, authCredential: orgUrl }` When the MFA or password-reset completes and a new session is established, you can retry with `authCredential: orgUrl` without regenerating the Frontdoor URL. If the retry fails, regenerate Frontdoor URL and retry. **See Also** - [`initializeAnalyticsSdk`](/docs/analytics/sdk/references/sdk-js-v2/initializeAnalyticsSdk.html) - [`AnalyticsDashboard`](/docs/analytics/sdk/references/sdk-js-v2/AnalyticsDashboard.html) - [`AnalyticsFilter`](/docs/analytics/sdk/references/sdk-js-v2/AnalyticsFilter.html) - [`AnalyticsMetric`](/docs/analytics/sdk/references/sdk-js-v2/AnalyticsMetric.html) - [`AnalyticsVisualization`](/docs/analytics/sdk/references/sdk-js-v2/AnalyticsVisualization.html) # Add Actions to Dimensions Set up record-level actions on a dimension so that dashboard viewers can perform actions directly from a CRM Analytics chart or table. Each action applies to a single Salesforce record, such as creating a task for an opportunity record. You can also create an action to open the Salesforce record or a URL. **important:** Salesforce recommends that you set up actions using the UI because it’s easier. For information about setting up actions with clicks, not code, see [Perform Actions on a Salesforce Record from CRM Analytics](https://help.salesforce.com/articleView?id=bi_dashboards_actions_configure.htm). ## Open a Salesforce Record You can add a link in the action menu to open a Salesforce record directly from CRM Analytics charts and tables. The link name appears as Open Record. To let the dashboard viewer know the purpose of the link, add a tooltip that appears when the user hovers over the link. ![The Open Record link appears in the action menu for each account.](https://developer.salesforce.com/media/bi_dev_guide_xmd/bi_xmd_actions_open_sfdc_record.png) CRM Analytics determines which record to open based on the Salesforce ID provided in the dataset field. When a user tries to open the record and multiple Salesforce records apply to the selected dimension, a popup asks which record to open. For example, the chart shows the value for all opportunities for each account. When the user tries to open the opportunity record for an account and the account has multiple opportunities, the user is prompted to select one. To help the user choose the correct record, the dataset fields show the opportunity name, account name, and owner for each opportunity. ![The dialog shows you information about each opportunity and asks you to pick a record.](https://developer.salesforce.com/media/bi_dev_guide_xmd/bi_xmd_actions_multimatch_show_dataset_fields.png) The bold text in the XMD example shows how to set up this type of action. ```nolang "dimensions": [{ "field": "Account.Name", "linkTemplateEnabled": true, "linkTooltip": "Open the opportunity record associated with this account.", "members": [], "recordDisplayFields": ["Name", "Account.Name", "Owner.Name"], "recordIdField": "Id", "salesforceActions": [], "salesforceActionsEnabled": false }], ``` ## Open a Salesforce Record in a Multi-Org Environment You can configure the action menu in a chart or table to open Salesforce records from multiple orgs. Before we get into how to configure the XMD, let’s look at an example. You previously loaded opportunity records from multiple orgs into a dataset. ![One opportunity from each of four orgs is loaded into the dataset.](https://developer.salesforce.com/media/bi_dev_guide_xmd/bi_xmd_dataset_load_from_sfdc_orgs.png) Now you want to allow dashboard viewers to open the Salesforce record directly from a dimension in a chart or table. To locate a Salesforce record in a multi-org environment, CRM Analytics needs the dataset fields that identify each Salesforce record and its org. To provide CRM Analytics with this information. - In the `recordIdField` and `recordOrganizationIdField` fields under `dimensions` specify the dataset fields that contain the record ID and org ID, respectively. ![The "dimensions" field shows the field, recordId, and recordOrganizationIdField XMD fields.](https://developer.salesforce.com/media/bi_dev_guide_xmd/bi_xmd_open_sfdc_record_multi-org_xmd_dimensions.png) - In the `id` and `instanceURL` fields under `organizations`, map the org IDs to the org URLs. You can also specify a label for each org. ![The "organizations" section of the XMD maps the org IDs to the org URLs.](https://developer.salesforce.com/media/bi_dev_guide_xmd/bi_xmd_open_sfdc_record_multi-org_xmd_organizations.png) When a user clicks the link to open a Salesforce record, CRM Analytics determines which Salesforce record to open by using the org URL and the record ID. CRM Analytics looks up the org ID in the dataset field specified in the `recordOrganizationIdField` of the XMD. It then uses the org ID to look up the org URL in the `organizations` section. CRM Analytics retrieves the record ID from the dataset field specified in the `recordIdField` field of the XMD. For example, if the org URL is https://mydomain.salesforce.com and the record ID is 006f4000002fjpCAAQ, the link to the record in its org is https://mydomain.salesforce.com/006f4000002fjpCAAQ. The bold text in the XMD example shows how to set up this type of action. ```nolang "dimensions": [{ "field": "Account.Name", "label": "Account Name", "linkTemplateEnabled": true, "members": [], "recordDisplayFields": [ "Account.Name", "Account.Owner.Name", "Account.Owner.Role.ParentRoleId" ], "recordIdField": "AccountId", "recordOrganizationIdField": "SFOrgId", "salesforceActions": [], "salesforceActionsEnabled": false }], ``` This XMD snippet shows the `organizations` XMD parameter. ```nolang "organizations": [ { "id": "00DB00000003brXMAQ", "instanceUrl": "https://westregion.salesforce.com", "label": "West Region Org" }, { "id": "00DB0000000pqd1MAA", "instanceUrl": "https://eastregion.salesforce.com", "label": "East Region Org" }, { "id": "00DB0000000paacMAA", "instanceUrl": "https://southregion.salesforce.com", "label": "South Region Org" }, { "id": "00DB00000001234MAA", "instanceUrl": "https://northregion.salesforce.com", "label": "North Region Org" } ] ``` ## Open a Website You can add a link to open a website from charts and tables. You can pass dataset field values in the URL using the following syntax. ```nolang “{{row.}}" ``` The bold text in the XMD example shows how to set up this type of action. ```nolang "dimensions": [{ "field": "CompanyName", "linkTemplate": "http://www.google.com/search?q={{row.CompanyName}}", "linkTemplateEnabled": true, "linkTooltip": "Search Google for this company name.", "members": [], "recordDisplayFields": [], "salesforceActions": [], "salesforceActionsEnabled": false }], ``` When a dashboard viewer clicks the Open Record link, CRM Analytics performs a search in Google based on the company name specified in the CompanyName dataset field. ![The Open Record link appears in the action menu for each company.](https://developer.salesforce.com/media/bi_dev_guide_xmd/bi_xmd_actions_open_website.png) ## Perform a Salesforce Action on a Salesforce Record from CRM Analytics You can add Salesforce actions to the action menu. You can only add actions defined in the page layouts for the corresponding Salesforce object. Actions are only available for the local org, and are not supported for multi-org records. The bold text in the XMD example shows how to set up this type of action. In this example, all actions defined for any page layout for the object show up in the actions menu. ```nolang "dimensions": [{ "field": "Name", "linkTemplateEnabled": false, "members": [], "recordDisplayFields": ["Name", "Owner.Name", "Account.Name"], "recordIdField": "Id", "salesforceActions": [], "salesforceActionsEnabled": true }], ``` The list of all actions defined in all page layouts for this object appear in the actions menu. **note:** Each dashboard viewer sees only the actions that are assigned to the viewer’s page layout for this object. ![The actions menu shows all Salesforce actions defined for the object.](https://developer.salesforce.com/media/bi_dev_guide_xmd/bi_xmd_actions_allSfdcActions.png) In this example, only the specified set of actions defined in the page layouts show up in the actions menu. ```nolang "dimensions": [{ "field": "Name", "linkTemplateEnabled": false, "members": [], "recordDisplayFields": ["Name", "Owner.Name", "Account.Name"], "recordIdField": "Id", "salesforceActions": [{ "enabled": true, "name": "NewCase" }, { "enabled": true, "name": "NewEvent" }, { "enabled": true, "name": "NewContact" }, { "enabled": true, "name": "NewLead" }], "salesforceActionsEnabled": true }], ``` **See Also** - [Dimensions and Derived Dimensions in XMD](https://developer.salesforce.com/docs/analytics/bi-dev-guide-xmd/reference/bi-xmd-reference-dimensions.md) - [Organizations in XMD](https://developer.salesforce.com/docs/analytics/bi-dev-guide-xmd/reference/bi-xmd-reference-organizations.md) # Add an Einstein Discovery Story to a CRM Analytics Template Einstein Discovery stories can be added to an app template by referring to the story in the `template-info.json` file. ## Create the Story Before adding the story to a template, create it using Einstein Discovery. (See [Create a Story](https://help.salesforce.com/articleView?id=bi_edd_create.htm&type=5).) We recommend testing your story in CRM Analytics Studio before adding it to a template. Also, add the story JSON to the template. See the following section “Configure a Story” for instructions about editing the story JSON dynamically with a template rule. **note:** Templates only support Einstein Discovery stories with a numeric, binary, and multiclass analysis prediction types in the outcome. The count analysis prediction type isn't supported. ## Reference the Story in template-info.json To include the story in the template, add the following to `template-info.json`: ```nolang "extendedTypes":{ "discoveryStories": [ { "label": "AcquiredAccounts", "name": "acquired_accounts", "file": "acquired-accounts-story.json" "condition" : "${Variables.StringValueInclude == 'Yes'}" }, { "label": "AcquiredAccounts2", "name": "acquired_accounts2", "file": "acquired-accounts-story2.json" } ] } ``` To add multiple stories to a template, add a `discoveryStories` entry for each story. Add a conditional to exclude or include the story based on a variable the user selects in the wizard, available org data, or some other condition. ## Story Metadata Examples Here’s an example `acquired-accounts-story.json` file for a story with a non-Boolean outcome. ```nolang { "outcome": { "type": "Number", "label": "CLV", "name": "CLV", "goal": "Maximize" }, "autopilot": { "enabled": true }, "setup": { "dataset": { "id": "${App.Datasets.opportunities.Id}" }, "outcome": { "type": "Number", "label": "CLV", "name": "CLV", "goal": "Maximize" }, "fields": [{ "type": "text", "name": "Account Id" }, { "type": "text", "name": "BillingState" }, { "type": "date", "name": "StartDate" }, { "type": "number", "name": "example" } ... ] } } ``` For a boolean outcome, use something like the following: ```nolang "outcome": { "failureValue": "False", "goal": "Maximize", "label": "IsWon", "name": "IsWon", "successValue": "True", "type": "Text" }, "setup": { "outcome": { "type": "text", "name": "IsWon", "displayName": "IsWon", "success": "True", "failure": "False", "goal": "Maximize" },... } ``` Syntax notes: - The `id` value in `dataset` must match a dataset specified in `template-info.json`. You can only create one story per dataset in a template. - Story metadata is case-sensitive. Capitalize the first letter in outcome, and use lowercase for fields. - All fields are required in the `outcome` object. - `outcome` and `setup.outcome` must be the same. - The outcome name is the variable we want the story to identify. For example, in the above, we want to learn if the outcome is `IsWon`. - Number of fields can be a minimum of 2 and maximum of 50 - Fields are the columns of data analyzed by Einstein Discovery and included in the story. - The `autopilot` object is optional. The default value is `false`. ## Configure a Story You can add filters to fields in the story. In the following example, we only consider rows where IsClosed = true. ```nolang "fields": [ { "type": "text", "name": "IsClosed", "includeOther": false, "values": [ { "name" : "true", "ignored":false }, { "name" : "false", "ignored":true } ] } ] ``` Use caution when adding date fields. Adding a field that shows individual dates (for example, 2019-07-01), isn’t helpful in the story. Instead, it makes more sense to show months. ```nolang { "type": "date", "name": "CloseDate", "periodicIntervals": [ "MONTH_OF_YEAR" ], "interval": "NONE" } ``` Multivalue fields can’t be included in a story. They’re excluded from the list in the story UI and must not be added to the story json. Create or alter the story JSON using template rules. For example, the following rule loops through a measures variable and adds each field to the story JSON: ```nolang { "condition": "${!empty(Variables.Dataset_Measures[0].fieldName)}", "action": "set", "description": "put selected fields in ED Story json", "path": "$.setup.fields", "value": "${array:union(Rules.CurrentNode, array:forEach(Variables.Dataset_Measures,'{\"type\":\"number\", \"name\": \"${var.fieldName}\"}'))}" } ``` Here’s a rule that conditionally adds a competitor name if it’s selected in the wizard: ```nolang { "condition": "${!empty(Variables.Competitor.fieldName)}", "type": "text", "name": "${Variables.Competitor.fieldName}" } ``` Here’s another that adds only month of the year values to the story: ```nolang { "condition": "${!empty(Variables.Dataset_Dates[0].dateAlias)}", "action": "set", "description": "put selected fields in ED Story json", "path": "$.setup.fields", "value": "${array:union(Rules.CurrentNode, array:forEach(Variables.Dataset_Dates,'{\"type\":\"date\", \"name\": \"${var.dateAlias}\", \"periodicIntervals\": [\"MONTH_OF_YEAR\"], \"interval\": \"NONE\"}'))}" } ``` # Add Event Listeners for Tableau Next Components The SDK supports various events that your component can listen for and apply event handling logic to. Supported events include: - `COMPONENT_LOADED`: Generated when the component loads completely. - `UPDATED_FILTERS`: Generated when the component filters update. - `UPDATED_SELECTIONS`: Generated when the component selections update. - `UPDATED_TIME_RANGE`: Generated when the time range for `AnalyticsMetric` updates. - `RECEIVED_DATASOURCES`: Generated when the data sources for `AnalyticsDashboard` loads. - `RECEIVED_FIELDS`: Generated when fields associated with a component loads. - `RECEIVED_FILTERS`: Generated when a list of applied filters for a component loads. - `RECEIVED_FILTER_FIELD_VALUES`: Generated when filter field values associated with a component field loads. - `RECEIVED_INTERACTION_DETAILS`: Generated when the interaction details associated with a component loads. - `RECEIVED_LAYOUT`: Generated when an applied layout for `AnalyticsMetric` loads. - `RECEIVED_METADATA`: Generated when the metadata for a component loads. - `RECEIVED_PAGES`: Generated when a list of page labels for `AnalyticsDashboard` loads. - `RECEIVED_SELECTIONS`: Generated when a list of applied selections for `AnalyticsVisualization` loads. - `DEFAULT`: Generated when any unnamed event occurs. - `ERROR`: Generated when an error occurs. Use this to listen for errors. ## Example for Event Handling for Component Loaded ```javascript analyticsComponent.addEventListener(EventName.COMPONENT_LOADED, (event) => { // Implement event handling logic }); ``` ## Example for Error Handling Use the `analyticsEventTarget` to listen for `EventName.ERROR`, with a callback to handle errors that are thrown if the SDK initialization fails due to wrong `orgUrl` or `authCredentials`. ```javascript analyticsEventTarget.addEventListener(EventName.ERROR, (errorEvent) => { console.log("Received a global error event", errorEvent) }); ``` # Add Functionality to Tableau Next Embedded Components Once you have your components embedded in your third-party app, you can customize the component behavior with filters and events. - [Using Filters in Tableau Next Components](https://developer.salesforce.com/docs/analytics/sdk/guide/sdk-embedded-components-filters.md) - [Add Event Listeners for Tableau Next Components](https://developer.salesforce.com/docs/analytics/sdk/guide/sdk-embedded-components-events.md) - [Use Cases for Tableau Next Embedding](https://developer.salesforce.com/docs/analytics/sdk/guide/sdk-use-cases.md) # Add Tableau Next Components from Multiple Salesforce Orgs Embedding Tableau Next components in your own web app gives you the flexibility to add components from multiple Salesforce orgs on one page. To use multiple orgs in your implementation, initialize the SDK with the `orgConfigs` map instead of single `orgUrl` and `authCredential` parameters. ```javascript import { initializeAnalyticsSdk, AnalyticsDashboard, AnalyticsVisualization, } from "@salesforce/analytics-embedding-sdk"; // Initialize with multiple orgs, Lightning URL required for the `orgUrl` values const initPayload = { orgConfigs: [ { orgUrl: "https://org1.lightning.force.com", authCredential: "https://org1-frontdoor.salesforce.com/...", }, { orgUrl: "https://org2.lightning.force.com", authCredential: "https://org2-frontdoor.salesforce.com/...", }, ], }; const response = await initializeAnalyticsSdk(initPayload); ``` Then, when you embed your components, you must specify the `orgUrl` in the component constructor. The `orgUrl` is required when creating components in a multi org scenario, to ensure that your component connects to the correct org. ```javascript // Embed components from different orgs - always specify orgUrl const dashboard = new AnalyticsDashboard({ parentIdOrElement: "container1", idOrApiName: "Dashboard1", orgUrl: "https://org1.lightning.force.com", }); dashboard.render(); // Embed visualization from another org const visualization = new AnalyticsVisualization({ parentIdOrElement: "container2", idOrApiName: "Viz2", orgUrl: "https://org2.lightning.force.com", }); visualization.render(); ``` ## Adding Orgs Dynamically You can add new orgs or try failed orgs again after the initial SDK initialization by using the `retryOrAddOrgs` function. ```javascript import { retryOrAddOrgs } from "@salesforce/analytics-embedding-sdk"; const newOrgs = [ { orgUrl: "https://org3.lightning.force.com", authCredential: "https://org3-frontdoor.salesforce.com/...", }, { orgUrl: "https://org4.lightning.force.com", authCredential: "https://org4-frontdoor.salesforce.com/...", }, ]; const response = await retryOrAddOrgs(newOrgs); // Check if orgs were added successfully console.log(response.status); ``` The `retryOrAddOrgs` function returns the same `BootstrapResponse` format as the `initializeAnalyticsSdk` function. ## Response The `initializeAnalyticsSdk` function returns a `BootstrapResponse` object, which contains an `orgStates` map with the overall status and the individual org statuses. ```javascript const response = await initializeAnalyticsSdk(config); // Response structure: { "message": "Sdk Initialize Complete", "status": "Success", "orgStates": { "https://org1.lightning.force.com": { "state": "INITIALIZATION_SUCCESS", "reason": "" }, "https://org2.lightning.force.com": { "state": "INITIALIZATION_SUCCESS", "reason": "" } } } // Check initialization status console.log(response.status); // Get detailed message console.log(response.message); // For multi-org scenarios, check individual org states: if (response.orgStates) { response.orgStates.forEach((state, orgUrl) => { console.log(`Org ${orgUrl}: ${state.state}`); }); } ``` ### SDK Initialization Status Values - `Status.SUCCESS` - All orgs initialized successfully - `Status.PARTIAL_SUCCESS` - Some orgs initialized successfully (multi-org only) - `Status.FAILURE` - Initialization failed **See Also** - [`initializeAnalyticsSdk`](/docs/analytics/sdk/references/sdk-js-v2/initializeAnalyticsSdk.html) - [`retryOrAddOrgs`](/docs/analytics/sdk/references/sdk-js-v2/retryOrAddOrgs.html) - [`OrgConfig`](/docs/analytics/sdk/references/sdk-js-v2/OrgConfig.html) - [`OrgStateMap`](/docs/analytics/sdk/references/sdk-js-v2/OrgStatesMap.html) - [`OrgStateInfo`](/docs/analytics/sdk/references/sdk-js-v2/OrgStateInfo.html) # Add the Data When uploading external data files, you can use the InsightsExternalDataPart object to load the data in smaller chunks. After inserting a row into the InsightsExternalData (header) object, split your data into 10-MB chunks and upload the chunks to InsightsExternalDataPart objects. You associate the part objects with the header object by setting the InsightsExternalDataId field on the part objects to the ID of the header object. The part objects contain the bytes of data and must be assigned part numbers in a contiguous sequence, starting with 1. Ensure that the chunks of data are smaller than 10 MB. If the data is compressed, it must be compressed first and then split into 10-MB chunks. Only the gzip format is supported. The following example splits a file into 10-MB chunks, and then uploads the chunks to InsightsExternalDataPart objects. ```nolang List fileParts = chunkBinary(dataFile); //Split the file for(int i = 0;i # Aggregate Functions Aggregate functions perform computations across all values of a grouped field. If you don't precede an aggregate function by a `group by` statement, it treats each line as its own group. Using an aggregate function on an empty set returns null. - **[avg() or average()](https://developer.salesforce.com/docs/analytics/bi-dev-guide-saql/concept/bi-saql-fn-agg-avg.md)** Returns the average of the values of a measure field. - **[count()](https://developer.salesforce.com/docs/analytics/bi-dev-guide-saql/concept/bi-saql-fn-agg-cnt.md)** Returns the number of rows that match the query criteria. - **[first()](https://developer.salesforce.com/docs/analytics/bi-dev-guide-saql/concept/bi-saql-fn-agg-1st.md)** Returns the first value for the specified field. - **[last()](https://developer.salesforce.com/docs/analytics/bi-dev-guide-saql/concept/bi-saql-fn-agg-last.md)** Returns the last value in the tuple for the specified field. - **[max()](https://developer.salesforce.com/docs/analytics/bi-dev-guide-saql/concept/bi-saql-fn-agg-max.md)** Returns the maximum value of a dimension or measure field. - **[median()](https://developer.salesforce.com/docs/analytics/bi-dev-guide-saql/concept/bi-saql-fn-agg-med.md)** Returns the median value of a measure field. - **[min()](https://developer.salesforce.com/docs/analytics/bi-dev-guide-saql/concept/bi-saql-fn-agg-min.md)** Returns the minimum value of a dimension or measure field. - **[sum()](https://developer.salesforce.com/docs/analytics/bi-dev-guide-saql/concept/bi-saql-fn-agg-sum.md)** Returns the sum of a numeric field. - **[unique()](https://developer.salesforce.com/docs/analytics/bi-dev-guide-saql/concept/bi-saql-fn-agg-unq.md)** Returns the count of unique values. - **[stddev()](https://developer.salesforce.com/docs/analytics/bi-dev-guide-saql/concept/bi-saql-fn-agg-stdev.md)** Returns the standard deviation of the values in a field. Accepts measure fields (but not expressions) as input. - **[stddevp()](https://developer.salesforce.com/docs/analytics/bi-dev-guide-saql/concept/bi-saql-fn-agg-stdevp.md)** Returns the population standard deviation of the values in a field. Accepts measure fields as input but not expressions. - **[var()](https://developer.salesforce.com/docs/analytics/bi-dev-guide-saql/concept/bi-saql-fn-agg-var.md)** Returns the variance of the values in a field. Accepts measure fields as input but not expressions. - **[varp()](https://developer.salesforce.com/docs/analytics/bi-dev-guide-saql/concept/bi-saql-fn-agg-varp.md)** Returns the variance of the values in a field. Accepts measure fields as input but not expressions. - **[percentile_cont()](https://developer.salesforce.com/docs/analytics/bi-dev-guide-saql/concept/bi-saql-fn-agg-pc.md)** Calculates a percentile based on a continuous distribution of the column value. - **[percentile_disc()](https://developer.salesforce.com/docs/analytics/bi-dev-guide-saql/concept/bi-saql-fn-agg-pd.md)** Returns the value corresponding to the specified percentile. - **[regr_intercept()](https://developer.salesforce.com/docs/analytics/bi-dev-guide-saql/concept/bi-saql-fn-agg-ri.md)** Uses two numerical fields to calculate a trend line, then returns the y-intercept value. Use this function to find out the likely value of _field_y_ when _field_x_ is zero. - **[regr_slope()](https://developer.salesforce.com/docs/analytics/bi-dev-guide-saql/concept/bi-saql-fn-agg-rs.md)** Uses two numerical fields to calculate a trend line, then returns the slope. Use this function to learn more about the relationship between two numerical fields. - **[regr_r2()](https://developer.salesforce.com/docs/analytics/bi-dev-guide-saql/concept/bi-saql-fn-agg-regr2.md)** Uses two numerical fields to calculate R-squared, or goodness of fit. Use `regr_r2()` to understand how well the trend line fits your data. - **[grouping()](https://developer.salesforce.com/docs/analytics/bi-dev-guide-saql/concept/bi-saql-fn-agg-grouping.md)** Returns 1 if null dimension values are due to higher-level aggregates (which usually means the row is a subtotal or grand total), otherwise returns 0. **See Also** - [group-by](https://developer.salesforce.com/docs/analytics/bi-dev-guide-saql/guide/bi-saql-statement-groupby.md) # Aggregate Functions Aggregate functions perform operations across columns. CRM Analytics supports the following aggregate functions. - **[avg()](https://developer.salesforce.com/docs/analytics/bi-dev-guide-sql/guide/bi-sql-aggregate-avg.md)** Takes the average of row values in a given column. - **[count()](https://developer.salesforce.com/docs/analytics/bi-dev-guide-sql/guide/bi-sql-aggregate-count.md)** Returns the number of rows that match a specified condition in a column. - **[min()](https://developer.salesforce.com/docs/analytics/bi-dev-guide-sql/guide/bi-sql-aggregate-min.md)** Returns the lowest row value in a numeric column. - **[max()](https://developer.salesforce.com/docs/analytics/bi-dev-guide-sql/guide/bi-sql-aggregate-max.md)** Returns the highest row value in a numeric column. - **[sum()](https://developer.salesforce.com/docs/analytics/bi-dev-guide-sql/guide/bi-sql-aggregate-sum.md)** Returns the sum of all rows values in a numeric column. - **[stddev_pop()](https://developer.salesforce.com/docs/analytics/bi-dev-guide-sql/guide/bi-sql-aggregate-stddev-pop.md)** Returns the population standard deviation of the values in a field. Accepts measure fields as input. This function does not accept expressions. - **[stddev_samp()](https://developer.salesforce.com/docs/analytics/bi-dev-guide-sql/guide/bi-sql-aggregate-stddev-samp.md)** Returns the standard deviation of values in a field. Accepts measure fields as input. This function does not accept expressions. - **[var_pop()](https://developer.salesforce.com/docs/analytics/bi-dev-guide-sql/guide/bi-sql-aggregate-var-pop.md)** Returns the population variance of the values in a field. Accepts measure fields as input. This function does not accept expressions. - **[var_samp()](https://developer.salesforce.com/docs/analytics/bi-dev-guide-sql/guide/bi-sql-aggregate-var-samp.md)** Returns the sample variance of the values in a field. Accepts measure fields as input. This function does not accept expressions. - **[regr_intercept()](https://developer.salesforce.com/docs/analytics/bi-dev-guide-sql/guide/bi-sql-aggregate-regr-intercept.md)** Returns the y-intercept value of a regression line. - **[regr_slope()](https://developer.salesforce.com/docs/analytics/bi-dev-guide-sql/guide/bi-sql-aggregate-regr-slope.md)** Returns the slope of a regression line between two numerical fields. - **[regr_r2()](https://developer.salesforce.com/docs/analytics/bi-dev-guide-sql/guide/bi-sql-aggregate-regr-r2.md)** Returns the R-squared, or goodness-of-fit value for a regression. - **[percentile_cont](https://developer.salesforce.com/docs/analytics/bi-dev-guide-sql/guide/bi-sql-aggregate-pct-cont.md)** Calculates a percentile based on a continuous distribution of the column value. - **[percentile_disc](https://developer.salesforce.com/docs/analytics/bi-dev-guide-sql/guide/bi-sql-aggregate-pct-disc.md)** Returns the value corresponding to a given percentile. Accepts measure fields as input. # aggregateflex Step Type Properties Use the `aggregateflex` step type to perform aggregate queries on a Analytics dataset. An aggregate query summarizes rows, like returning one row per grouping. For example, this step type can return the total amount per sales rep. | Field Name | Description | | ------------------------- | ----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | | `datasets` | An array of datasets used by this step. Specify the alias of each dataset. If the `pigql` attribute references a dataset that's not specified here, the dashboard doesn't render. | | `broadcastFacet` | Controls whether the step's selections are broadcasted as facets. Faceting is when a selection in a widget filters other steps in the dashboard. Default is `true`. | | `receiveFacetSource` | Controls whether the step in the receiving query listens for broadcasted facets and applies them as filters. The mode can be "`all`", "`none`", "`include`", or "`exclude`". Use `steps` to list which steps to include or exclude. Default is `all`. | | `isGlobal` | This applies to global filters created before Winter '18 only. Newer global filters, those created in the global filter panel widget, don't require a step. Default is false. You can apply this property only on steps that are connected to a global filter widget—all other steps ignore this property. A global filter filters other steps in the dashboard that have `useGlobal` set to `true` and reference the same dataset. | | `label` | Step label, which is primarily used for display in the dashboard designer user interface. | | `query` | The query used to retrieve results from a dataset. It must contain at least one grouping and can be in SAQL or compact form. Use a query in SAQL form to customize the query in a way that can't be done using compact form. | | `selectMode` | Determines the selection interaction. The options for charts, tables, lists, and toggle selectors are: `none`, `single`, `singlerequired`, `multi` and `multirequired`. `selectMode` doesn't apply to number, values table, date, range, and global filter widgets. | | `start` | The initial selections that are applied to the step when the dashboard first opens. | | `type` | Step type. Set to `aggregateflex`. If you bind a step property for an `aggregateflex` step, you must use the correct bindings syntax. For more information about bindings, see the [Analytics Bindings Developer Guide](https://developer.salesforce.com/docs/atlas.en-us.bi_dev_guide_bindings.meta/bi_dev_guide_bindings/bi_dbjson_bindings.htm). | | `visualizationParameters` | Visualization details about the step. For more information, see [visualizationParameters Properties](https://developer.salesforce.com/docs/analytics/bi-dev-guide-json/guide/bi-dbjson-steps-visualizationparameters-properties.md). | | `useGlobal` | Indicates whether to apply global filters to this step (`true`) or not (`false`). If the step is in SAQL form, you must also set `autoFilter` to `true` to apply the global filters. By default, the global filter widget filters compact-form steps only. | ## Compact Form 2.0 Query Properties The `query` can contain the following properties. - `sources` — The array of sources where data comes from. For more information, see [sources Properties](https://developer.salesforce.com/docs/analytics/bi-dev-guide-json/guide/bi-dbjson-steps-sources.md). - `sourceFilters` — The filters applied to `sources`. When you use this object, the `sources` name is the `steps` key. the For more information, see [filters Properties](https://developer.salesforce.com/docs/analytics/bi-dev-guide-json/guide/bi-dbjson-steps-filters.md). - `aggregateFilters` — The array of filters applied on aggregate columns, which are fields where an aggregate function, such as average or sum, is applied to a measure column. Aggregate columns are defined in `columns` under `sources`. For more information, see [filters Properties](https://developer.salesforce.com/docs/analytics/bi-dev-guide-json/guide/bi-dbjson-steps-filters.md) - `orders` — The array of sort orders applied to data in a pivot table. An order can contain the following properties: - `name` — The column or group name used to apply the sort order. - `ascending`: The sort order applied to the data. Indicates whether to order the data in ascending order (`true`) or not (`false`). - `filters` — The filters used to sort a measure column in a pivot table and is applied on a dimension value in the pivoted group. For more information about sorting data in a pivot table, see [Organize and Summarize Data in a Pivot Table](https://help.salesforce.com/articleView?id=analytics.bi_explorer_pivot_table.htm&type=5). - `nulls` — The sort order applied to null values in the data. To sort null values last, set `nulls` to `last`. To sort null values first, set `nulls` to `first`. - `rowTotals` — The array of dimension groups to which the values of each row are rolled up. To calculate `rowTotals`, you must also include `columnGroups` for the data. - `columnTotals` — The array of dimension groups to which the values of each column are rolled up. If the query is a grain query, that is, all the columns are non-aggregate columns, or if the query is not grouped by any dimension columns, to calculate totals, set `columnTotals` to `all`. - `columnGroups` — The pivoted dimension group, which is the last-defined group. If the defined group is a compound date, such as Year-Month for order date, then include each date grain in `columnGroups`. For example, `["OrderDate_Year", "OrderDate_Month"]`. - `limit` — The maximum number of results that the step can return. When you create an `aggregateflex` step, by default, CRM Analytics sets `limit` to 2,000. To return more results, set the `limit` attribute accordingly. The higher you increase the limit, the longer the query takes. When a limit isn't set, Analytics returns up to 10,000 results. For more information, see [filters Properties](https://developer.salesforce.com/docs/analytics/bi-dev-guide-json/guide/bi-dbjson-steps-filters.md). Compact Form 2.0 Query Example: ```nolang "query": { "sources": [ { "columns": [ { "field": ["sum", "Amount"], "name": "A" } ], "groups": [ "Product_Container", "Order_priority" ], "filters": [ [ "Profit", [16000], "<", ] ], "name": "SuperStoreSales" }, { "columns": [ { "formula": "A*2", "name": "B" } ], "groups": [], "filters": [] ] }, ], "sourceFilters": { "SuperStoreSales" { "filters": [ [ "Sales", [ 1, 100000 ], ">=<=" ], [ "Customer_Segment", [ "Consumer", "Corporate", ], "in" ] ] } }, "aggregateFilters": [ [ "A", [10], ">" ] ], "orders": [ { "name": "Product_Container", "ascending": true, "filters": [], "nulls": "last" }, { "name": "Order_Priority", "ascending": true, "filters": [], "nulls": "last" } ], "rowTotals": ["Product_Container"], "columnTotals": [ "Product_Container", "Order_Priority" ], "columnGroups": ["Order_Priority"], "limit": 2000 } ``` ## Compact Form 1.0 Query Properties The `query` can contain the following properties. - `filters` — The filters to apply to the data. For more information, see [filters Properties](https://developer.salesforce.com/docs/analytics/bi-dev-guide-json/guide/bi-dbjson-steps-filters.md). - `groups` — The dimension to group by. - `limit` — The maximum number of results that the step can return. When you create an `aggregateflex` step, by default, CRM Analytics sets `limit` to 2,000. To return more results, set the `limit` attribute accordingly. The higher you increase the limit, the longer the query takes. When a limit isn't set, Analytics returns up to 10,000 results. Limit only impacts the number of records returned for display. The limit doesn't impact calculations across all records in the dataset. For instance, a query groups by Account Name and there are one million Account Names in a dataset. When the limit is 20, Analytics returns 20 records for display. But the summary row provides a total for the one million records. - `measures` — The measures returned by the query. If you provide an aggregate function for a measure, then the measure value must be a string, not an array. - `order` — Sort order (ascending or descending) of the first specified measure. To order the results in ascending order, set `ascending` to `true`. To order the results in descending order, set `ascending` to `false`. If you don't want to impose a specific order, remove the entire `"order"` parameter. - Compact-form (1.0) Query Example: ```nolang "query": { "filters": [ [ "Account.Industry", [ "Agriculture", "Apparel", "Banking", "Biotechnology", "Consulting", "Education", "Electronics", "Energy", "Engineering", "Finance", "Healthcare", "Insurance", "Manufacturing", "Media", "Retail", "Technology", "Telecommunications", "Transportation", "Utilities" ], "in" ] ], "groups": [ "Account.Industry" ], "measures": [ [ "avg", "Amount" ] ], "order": [ [ -1, { "ascending": false } ] ] } ``` ## SAQL Form Query Properties The `query` can contain these properties: - `pigql` — Specify the SAQL query to retrieve data from a dataset. When you specify a SAQL query, you must specify the filters, limits, and ordering inside the `pigql` attribute. CRM Analytics ignores the following attributes if they are set under the `query` attribute: `filters`, `limit`, and `order`. - `measures` — Defines the fields included as measures. When using a SAQL-form query, you must include each measure in this parameter and in the `pigql` parameter. You can change the UI label of a measure by setting the `display` option. ```nolang "count", "*", null, { "display": "% of total flights" } ``` - `groups` — Defines the dimension fields to group by. When using a SAQL-form query, you must specify the group-by dimension in this parameter and in the `group` property in the `pigql` parameter. - SAQL-form Query Example: ```nolang "query": { "pigql": "q = load \"ServiceOpportunity3\";\n q = filter q by 'Account.Industry' in [\"Agriculture\", \"Apparel\", \"Banking\", \"Biotechnology\", \"Consulting\", \"Education\", \"Electronics\", \"Energy\", \"Engineering\", \"Finance\", \"Healthcare\", \"Insurance\", \"Manufacturing\", \"Media\", \"Retail\", \"Technology\", \"Telecommunications\", \"Transportation\", \"Utilities\"];\n q = group q by 'Account.Industry';\n q = foreach q generate 'Account.Industry' as 'Account.Industry', count() as 'count';\n q = order q by 'count' desc;\n q = limit q 1000;", "measures": [ [ "count", "*", "count" ] ], "groups": [ "Account.Industry" ], "measuresMap": {} } ``` For more information about SAQL queries, see the [Analytics SAQL Developer Guide](https://developer.salesforce.com/docs/atlas.en-us.bi_dev_guide_saql.meta/bi_dev_guide_saql/bi_saql_intro.htm). ## Example ### aggregateflex Step ```nolang "steps": { "Account_Owner_1": { "type": "aggregateflex", "query": { "measures": [ [ "avg", "Amount" ] ], "groups": [ "Account_Owner" ], "order": [ [ "avg_Amount", { "ascending": false } ] ] }, "visualizationParameters": { "options": {}, "type": "chart", "parameters": { "visualizationType": "hbar", "autoFitMode": "keepLabels", "theme": "wave", "title": { "label": "", "fontSize": 14, "subtitleLabel": "", "subtitleFontSize": 11, "align": "center" }, "showValues": true, "axisMode": "multi", "binValues": false, "bins": { "breakpoints": { "low": 0, "high": 100 }, "bands": { "low": { "label": "", "color": "#B22222" }, "medium": { "label": "", "color": "#ffa500" }, "high": { "label": "", "color": "#008000" } } }, "dimensionAxis": { "showAxis": true, "showTitle": true, "title": "", "customSize": "auto", "icons": { "useIcons": false, "iconProps": { "column": "", "fit": "cover", "type": "round" } } }, "measureAxis1": { "sqrtScale": false, "showAxis": true, "customDomain": { "showDomain": false }, "showTitle": true, "title": "" }, "measureAxis2": { "sqrtScale": false, "showAxis": true, "customDomain": { "showDomain": false }, "showTitle": true, "title": "" }, "legend": { "show": true, "showHeader": true, "inside": false, "descOrder": false, "position": "right-top", "customSize": "auto" }, "tooltip": { "customizeTooltip": false, "showDimensions": true, "dimensions": "", "showMeasures": true, "measures": "", "showPercentage": true, "showNullValues": true, "showBinLabel": true }, "trellis": { "enable": false, "showGridLines": true, "flipLabels": false, "type": "x", "chartsPerLine": 4, "size": [ 100, 100 ] }, "applyConditionalFormatting": true, "showActionMenu": true, "columnMap": { "trellis": [], "plots": [ "avg_Amount" ], "dimensionAxis": [ "Account_Owner" ] } } }, "datasets": [ { "id": "0FbB00000000xHDKAY", "name": "DTC_Opportunity_SAMPLE", "label": "DTC Opportunity", "url": "/services/data/v48.0/wave/datasets/0FbB00000000xHDKAY" } ], "useGlobal": true, "isGlobal": false, "label": "Account_Owner_1", "broadcastFacet": true, "receiveFacetSource": { "mode": "all", "steps": [] }, "selectMode": "single" } } ``` - **[steps Properties for Compact Form and SAQL Form](https://developer.salesforce.com/docs/analytics/bi-dev-guide-json/guide/bi-dbjson-steps-form.md)** The properties and JSON syntax in the `query` node of an `aggregateflex` step type vary based on whether the step is in compact form or SAQL form. # Analytics CLI Plugin Command Reference Previous PDF Versions | API Version | Release | PDF | | ----------- | ---------- | --- | | 68.0 | Winter '27 | [Download PDF](https://resources.docs.salesforce.com/264/latest/en-us/sfdc/pdf/bi_dev_guide_cli_reference.pdf) | | 67.0 | Summer '26 | [Download PDF](https://resources.docs.salesforce.com/262/latest/en-us/sfdc/pdf/bi_dev_guide_cli_reference.pdf) | | 66.0 | Spring '26 | [Download PDF](https://resources.docs.salesforce.com/260/latest/en-us/sfdc/pdf/bi_dev_guide_cli_reference.pdf) | | 65.0 | Winter '26 | [Download PDF](https://resources.docs.salesforce.com/258/latest/en-us/sfdc/pdf/bi_dev_guide_cli_reference.pdf) | # Analytics Dashboard Component Release Notes Use the Salesforce Release Notes to learn about the most recent updates to the Analytics Dashboard Component. For a list of all current developer additions and changes, including the Analytics Dashboard Component, see [CRM Analytics Release Notes](https://help.salesforce.com/s/articleView?id=release-notes.rn_bi_analytics_cloud.htm) in the Salesforce Release Notes. # Analytics Dashboard JSON Developer Guide Previous PDF Versions | API Version | Release | PDF | | ----------- | ---------- | ----------------------------------------------------------------------------------------------------- | | 67.0 | Summer '26 | [Download PDF](https://resources.docs.salesforce.com/262/latest/en-us/sfdc/pdf/bi_dev_guide_json.pdf) | | 66.0 | Spring '26 | [Download PDF](https://resources.docs.salesforce.com/260/latest/en-us/sfdc/pdf/bi_dev_guide_json.pdf) | | 65.0 | Winter '26 | [Download PDF](https://resources.docs.salesforce.com/258/latest/en-us/sfdc/pdf/bi_dev_guide_json.pdf) | | 64.0 | Summer '25 | [Download PDF](https://resources.docs.salesforce.com/256/latest/en-us/sfdc/pdf/bi_dev_guide_json.pdf) | # Analytics Dashboard Use Cases for Aura Components For the best result, use the dashboard component interactively with other components. This section has basic use cases to get you started on how to use the component methods, attributes, and Web SDK events. - [Get and Set the Dashboard State](https://developer.salesforce.com/docs/analytics/dashboard-component/guide/bi-dbcomp-stateusecase.md) # Analytics Download Download a `.png` image of a CRM Analytics dashboard or lens, or Lightning Experience dashboard or report. Download a `.pdf` file of a CRM Analytics dashboard or lens. Request downloads via browser calls. ## Syntax **URI:** `domain/analytics/download/assetType/assetId.downloadType` **note:** To request a download, enter the URI in a browser address bar. We don't support the use of this API from Apex. **Formats:** `.png` or `.pdf` **Parameters** | Parameter | Description | | -------------- | -------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | | `assetType` | Required. Specifies what type of Analytics asset to download. Valid values are:
  • `dashboard`
  • `lens`
  • `lightning-dashboard`
  • `report`
| | `assetId` | Required. Specifies the Analytics asset id to download. | | `downloadType` | Required. Specifies what file type to download the Analytics asset as. Valid values are:
  • `png`
  • `pdf`
| **note:** For Lightning Experience reports, the request works only with `png` and only if the report has a chart. If you use `pdf` or if the report doesn’t have a chart, the request returns an error. **Query Parameters** | Parameter | Description | | ------------- | -------------------------------------------------------------------------------------------------------------------------------- | | `includeData` | Optional. Indicates whether to include that tabular widget data (`true`) or not(`false`). | | `pageId` | Optional. Specifies the Id for a dashboard page to download. | | `pageSize` | Optional. Specifies page size to download. Valid values are:
  • `A3`
  • `A4`
  • `LEGAL`
  • `LETTER`
| | `savedviewId` | Optional. Specifies the Id for a dashboard saved view to download. | **note:** For Lightning Experience reports, the request works only with `png` and only if the report has a chart. If you use `pdf` or if the report doesn’t have a chart, the request returns an error. ## Response Body The response body is binary data of the `.png` or `.pdf` representation of the Analytics asset. For limits on columns and pages in `.pdf` files, see [Analytics Download Limits](https://help.salesforce.com/apex/HTViewHelpDoc?id=bi_limits.htm&language=en_US#AnalyticsDownloadLimits). # Analytics Download Use the Analytics Download API to download images and PDFs of Analytics assets, including CRM Analytics dashboards and lenses and Lightning Experience dashboards and reports. The Analytics Download API is available in API version 55.0 and later. **note:** To use the Analytics Download API, your org must have a CRM Analytics license. In addition, your org needs both Slack for Salesforce and CRM Analytics for Slack enabled. For more information, see [Enable Salesforce for Slack Integrations](https://help.salesforce.com/s/articleView?id=slack.slack_apps_enable.htm&type=5). Resources for the Analytics Download API are available at `domain/analytics/download`. Downloads are requested via browser calls. |Resource|Description| |--------|-----------| |[Analytics Download](https://developer.salesforce.com/docs/analytics/salesforce-analytics-rest-api/guide/analytics-api-download-reference-download.md) `domain/analytics/download/assetType/Id.downloadType`|When _downloadType_ has a value of `png`, downloads a `.png` image of the specified CRM Analytics dashboard or lens, or of the specified Lightning report or dashboard. When _downloadType_ has a value of `pdf`, downloads a `.pdf` file of the specified CRM Analytics dashboard or lens.| # analytics enable Enable Analytics in the target org. ## Examples for analytics enable ```nolang sf analytics enable ``` ```nolang sf analytics enable -o "MyTargetOrg" ``` ## Command Syntax - `sf analytics enable` - : [`--json`] [`--api-version` APIVERSION] `-o` TARGETORG [`-a`] [`-w` WAIT] [`-p` POLLINTERVAL] ## Parameters - `-o` TARGETORG - : Required Username or alias of the target org. Not required if the target-org configuration variable is set. Type: string - `--json` - : Optional Format output as JSON. Type: boolean - `--apiversion` APIVERSION - : Optional Override the API version used for API requests made by this command. Type: string - `-a` | `--async` - : Optional Enable asynchronously. Type: boolean - `-w` | `--wait` WAIT - : Optional Wait time in minutes for auto-install request to finish (default 10). Type: number Default value: 10 - `-p` | `--pollinterval` POLLINTERVAL - : Optional Polling interval in milliseconds for checking auto-install request status (default 5000). Type: number Default value: 5000 # Analytics Extended Metadata (XMD) Developer Guide Previous PDF Versions | API Version | Release | PDF | | ----------- | ---------- | ---------------------------------------------------------------------------------------------------- | | 67.0 | Summer '26 | [Download PDF](https://resources.docs.salesforce.com/262/latest/en-us/sfdc/pdf/bi_dev_guide_xmd.pdf) | | 66.0 | Spring '26 | [Download PDF](https://resources.docs.salesforce.com/260/latest/en-us/sfdc/pdf/bi_dev_guide_xmd.pdf) | | 65.0 | Winter '26 | [Download PDF](https://resources.docs.salesforce.com/258/latest/en-us/sfdc/pdf/bi_dev_guide_xmd.pdf) | | 64.0 | Summer '25 | [Download PDF](https://resources.docs.salesforce.com/256/latest/en-us/sfdc/pdf/bi_dev_guide_xmd.pdf) | # Analytics External Data API Developer Guide Previous PDF Versions | API Version | Release | PDF | | ----------- | ---------- | --------------------------------------------------------------------------------------------------------- | | 68.0 | Winter '27 | [Download PDF](https://resources.docs.salesforce.com/264/latest/en-us/sfdc/pdf/bi_dev_guide_ext_data.pdf) | | 67.0 | Summer '26 | [Download PDF](https://resources.docs.salesforce.com/262/latest/en-us/sfdc/pdf/bi_dev_guide_ext_data.pdf) | | 66.0 | Spring '26 | [Download PDF](https://resources.docs.salesforce.com/260/latest/en-us/sfdc/pdf/bi_dev_guide_ext_data.pdf) | | 65.0 | Winter '26 | [Download PDF](https://resources.docs.salesforce.com/258/latest/en-us/sfdc/pdf/bi_dev_guide_ext_data.pdf) | # Analytics Interactions Release Notes Use the Salesforce Release Notes to learn about the most recent updates to Analytics Interactions. For a list of all current developer additions and changes, including Analytics Interactions, see [CRM Analytics Release Notes](https://help.salesforce.com/s/articleView?id=release-notes.rn_bi_analytics_cloud.htm) in the Salesforce Release Notes. # Analytics Notification Get information about (`GET`), save changes to (`PUT`) or delete (`DELETE`) a specific analytics notification. ## Syntax **URI:** `/services/data/vXX.X/`analytics/notifications/_analytics notification ID_ **Formats:** JSON **HTTP methods** | Method | Description | | -------- | ---------------------------------------------------------------------------- | | `GET` | Returns information about a specific notification. | | `PUT` | Save changes to the analytics notification as specified in the request body. | | `DELETE` | Delete the analytics notification. Deleted notifications can't be recovered. | **Parameters** | Parameter | Description | | ---------- | -------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | | `source` | Required for `GET` calls. Specifies what type of analytics notification to return. Valid values are:
  • `lightningDashboardSubscribe` — dashboard subscriptions
  • `lightningReportSubscribe` — report subscriptions
  • `waveNotification` — Analytics notifications
| | `ownerId` | Optional for `GET` calls. Allows users with Manage Analytics Notifications permission to get notifications for another user with the specified `ownerId`. | | `recordId` | Optional. Return notifications for a single record. Valid values are:
  • `reportId`— Unique report ID
  • `lensId`— Unique Analytics lens ID
| ## GET Response Body | Property | Type | Description | | --------------------- | ------------------------------------------------------------------------------------------------ | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | | `active` | Boolean | Indicates whether the notification is being sent (`true`) or not (`false`). | | `configuration` | [WaveConfiguration[]](analytics-api-notifications-reference-list.md#analytics-notification-list) | Describes details of a Analytics notification. Only applicable when `source` is `waveNotification`. | | `createdDate` | DateTime | Date and time when the notification was created (in ISO 8601 format). | | `deactivateOnTrigger` | Boolean | Indicates whether the notification is deactivated after it's sent (`true`) or not (`false`). Deactivation doesn't delete the notification. The default value is `false`. | | `id` | String | Unique notification ID. | | `lastModifiedDate` | DateTime | Date and time when the notification was last modified (in ISO 8601 format). | | `name` | String | Display name of the notification. | | `recordId` | String | Unique ID of the record that the notification describes. Valid values are:
  • `reportId`
  • `lensId`
| | `runAs` | [runAs](https://developer.salesforce.com/docs/analytics/salesforce-analytics-rest-api/guide/analytics-api-notifications-reference-list.md) | The person who runs the report in a report subscription. Report recipients see data in the emailed report that this person has access to in Salesforce. Available in API version 40.0 and later. Only appears if you have the “Subscribe to Reports: Add Recipients” user perm. | | `schedule` | [Schedule](https://developer.salesforce.com/docs/analytics/salesforce-analytics-rest-api/guide/analytics-api-notifications-reference-list.md) | Details about the notification's schedule. | | `source` | String | Indicates the type of notification. Possible values are:
  • `lightningSubscribe` — report subscriptions
  • `lightningDashboardSubscribe` — dashboard subscriptions
  • `lightningReportSubscribe` — report subscriptions
  • `waveNotification` — Analytics notifications
| | `thresholds` | [Threshold[]](analytics-api-notifications-reference-list.md#analytics-notification-list) | Specifies what happens when the notification runs. For example, sending an email with report results. | **runAs** | Property | Type | Description | | -------- | ------ | --------------------------------------- | | `id` | String | The person’s unique Salesforce user ID. | | `name` | String | The person’s first and last name. | **Schedule** | Property | Type | Description | | --------------- | --------------------------------------------------------------------------------------------- | -------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | | `frequency` | String | How frequently the notification is invoked. Possible values are:
  • `daily` — Every day
  • `weekly` — One or more days each week
  • `monthly` — One or more days each month
| | `frequencyType` | String | Only necessary when `frequency` is `monthly`. Possible values are:
  • `relative` — Days which can change month-to-month, as described by `details`.
  • `specific` — Fixed monthly dates, as described by `details`.
| | `details` | [ScheduleDetail[]](analytics-api-notifications-reference-list.md#analytics-notification-list) | Describes the notification schedule. Varies depending on whether `frequency` is `daily`, `weekly`, or `monthly`. | **ScheduleDetail (`frequency` is `daily`)** | Property | Type | Description | | -------- | ------- | ---------------------------------------------------------------------------------------------------- | | `time` | Integer | The hour of the day at which the notification is invoked. Possible values are integers from 0 to 23. | **ScheduleDetail (`frequency` is `weekly`)** | Property | Type | Description | | ------------ | -------- | ----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | | `time` | Integer | The hour of the day at which the notification is invoked. Possible values are integers from 0 to 23. | | `daysOfWeek` | String[] | The days of the week on which the notification is invoked. Possible values are:
  • `mon` — Monday
  • `tue` — Tuesday
  • `wed` — Wednesday
  • `thu` — Thursday
  • `fri` — Friday
  • `sat` — Saturday
  • `sun` — Sunday
| **ScheduleDetail (`frequency` is `monthly`, `frequencyType` is `relative`)** | Property | Type | Description | | ------------- | ------- | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | | `time` | Integer | The hour of the day at which the notification is invoked. Possible values are integers from 0 to 23. | | `weekInMonth` | String | The week in the month during which the notification is invoked. Possible values are:
  • `first` — First week
  • `second` — Second week
  • `third` — Third week
  • `fourth` — Fourth week
| | `dayInWeek` | String | The day of the week on which the notification is invoked. Possible values are:
  • `mon` — Monday
  • `tue` — Tuesday
  • `wed` — Wednesday
  • `thu` — Thursday
  • `fri` — Friday
  • `sat` — Saturday
  • `sun` — Sunday
  • `weekday` — Weekday
  • `weekend` — Weekend day
| **ScheduleDetail (`frequency` is `monthly`, `frequencyType` is `specific`)** | Property | Type | Description | | ------------- | --------- | ----------------------------------------------------------------------------------------------------------------------------------------------------------- | | `time` | Integer | The hour of the day at which the notification is invoked. Possible values are integers from 0 to 23. | | `daysOfMonth` | Integer[] | The days of the month on which the notification is invoked. Possible values are integers from 1 to 31, and -1 (which represents the last day of the month). | **Threshold** | Property | Type | Description | | ------------ | ---------------------------------------------------------------------------------------- | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | | `actions` | [Action[]](analytics-api-notifications-reference-list.md#analytics-notification-list) | Specifies what action is taken when the notification is invoked. | | `conditions` | [Condition[]](analytics-api-notifications-reference-list.md#analytics-notification-list) | Describes conditions that govern when the notification is invoked. | | `type` | String | Specifies when the notification is invoked (other than date and time criteria). Possible values are:
  • `always` — Always invoke the notification
  • `onError` — Invoke the notification when there is an error
  • `condition` — Invoke the notification based on criteria described by `conditions`
| **Condition** | Property | Type | Description | | ----------- | ------ | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | | `colName` | String | The data field which is operated on. | | `value` | String | The comparison value which is used by the operation. | | `operation` | String | The operation which is used to evaluate the condition. Possible values are:
  • `equal` — `colName` and `value` are equal
  • `notEqual` — `colName` and `value` are not equal
  • `greaterThan` — `colName` is greater than `value`
  • `lessThan` — `colName` is less than `value`
  • `greaterThanEqual` — `colName` is greater than or equal to `value`
  • `lessThanEqual` — `colName` is less than or equal to `value`
| **Action** | Property | Type | Description | | --------------- | -------------------------------------------------------------------------------------------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | | `type` | String | The type of action to perform when the notification is invoked. Possible values are:
  • `postToSlack` — Post to a Slack channel
  • `sendEmail` — Send an email to `recipients`
| | `configuration` | [Configuration[]](analytics-api-notifications-reference-list.md#analytics-notification-list) | Specifies important attributes for resources related to the notification. | **Configuration** | Property | Type | Description | | ------------- | ---------------------------------------------------------------------------------------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------ | | `attachment` | String | Specifies whether a Lightning Experience report subscription includes an attachment. If it includes an attachment, also specifies the file attachment. There is only one valid value:
  • `excel` — Attach report results to the email as a spreadsheet formatted as a `.XLSX` file. Do not include record-level details in the subscription email.
If the Lightning report subscription does not include an attachment, then the `attachment` property is not returned. When the `attachment` property is not returned, HTML-formatted report results are included directly in the subscription email body. | | `recipients` | [Recipient[]](analytics-api-notifications-reference-list.md#analytics-notification-list) | A list of users, roles, and groups who receive the notification. | | `summaryOnly` | Boolean | Applies when threshold type is `condition` and `source=LightningReportSubscribe`. If `true`, emails the notification summary without the report table. If `false` or `null`, emails the summary and report table. | | `team` | [Team](https://developer.salesforce.com/docs/analytics/salesforce-analytics-rest-api/guide/analytics-api-notifications-reference-list.md#analytics-notification-list) | The team of notification recipients. | **Recipient** | Property | Type | Description | | ------------- | ------ | ---------------------------------------------------------------------------------------------------------------------------------------- | | `id` | String | Specifies who receives the notification. Valid values are the unique id of a user, role, or group. | | `displayName` | String | The `displayName` of the user, role, or group. | | `type` | String | Type of recipient. Possible values are:
  • `collaborationRoom` — A collaboration room.
  • `user` — A individual user.
| **Team** | Property | Type | Description | | ------------ | ------ | --------------------------------------- | | `platformId` | String | Specifies the id of the Slack platform. | **WaveConfiguration** | Property | Type | Description | | ---------- | ------------------------------------------------------------------------------------------ | ----------------------------------------------------------------------------------------- | | `anchor` | String | Optional. The Id of the Analytics dashboard widget to which the notification is anchored. | | `filter` | String | Optional. Description of selected filters at the time of notification creation. | | `query` | String | Required. SAQL query which is run when the notification is invoked. | | `datasets` | [WaveDataset[]](analytics-api-notifications-reference-list.md#analytics-notification-list) | Required. Collection of Analytics datasets referenced by the notification. | **WaveDataset** | Property | Type | Description | | ----------- | ------ | -------------------------------------------------- | | `id` | String | Required. Id of the Analytics dataset. | | `name` | String | Optional. Developer name of the Analytics dataset. | | `namespace` | String | Optional. Namespace of the Analytics dataset. | ## PUT Request Body A notification object with desired changes. Uses the same format as the GET response body. ## PUT Response Body An analytics notification object reflecting saved changes. Uses the same format as the GET response body. ## DELETE Response Body The analytics notification is deleted, and can't be recovered. Returns an empty response body. # Analytics Notification Limits Check to see how many more analytics notifications you can create. ## Syntax **URI:** `/services/data/vXX.X/analytics/notifications/limits?source=source` **Formats:** JSON **HTTP methods** |Method|Description| |------|-----------| |`GET`|Check how many analytic notifications you have, and the maximum number you can have.| **Parameters** |Parameter|Description| |---------|-----------| |`source`|Required for `GET` calls. Specifies what type of analytics notification to return. Valid values are:
  • `lightningDashboardSubscribe` — dashboard subscriptions
  • `lightningReportSubscribe` — report subscriptions
  • `waveNotification` — Analytics notifications
| |`recordId`|Optional. Return notifications for a single record. Valid values are:
  • `reportId`— Unique report ID
  • `lensId`— Unique Analytics lens ID
| ## GET Response Body |Property|Type|Description| |--------|----|-----------| |`max`|Integer|How many analytics notifications of the type specified by `source` the user is allowed to create.| |`remaining`|Integer|How many more analytics notifications of the type specified by `source` the user can create before hitting the limit.| # Analytics Notification List Return a list of analytics notifications (`GET`) or create an analytics notification (`POST`). ## Syntax **URI:** `/services/data/vXX.X/`analytics/notifications?source=source **Formats:** JSON **HTTP methods** | Method | Description | | ------ | ------------------------------------------ | | `GET` | Returns a list of analytics notifications. | | `POST` | Create an analytics notification. | **Parameters** | Parameter | Description | | ---------- | -------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | | `source` | Required for `GET` calls. Specifies what type of analytics notification to return. Valid values are:
  • `lightningDashboardSubscribe` — dashboard subscriptions
  • `lightningReportSubscribe` — report subscriptions
  • `waveNotification` — Analytics notifications
| | `ownerId` | Optional for `GET` calls. Allows users with Manage Analytics Notifications permission to get notifications for another user with the specified `ownerId`. | | `recordId` | Optional. Return notifications for a single record. Valid values are:
  • `reportId`— Unique report ID
  • `lensId`— Unique Analytics lens ID
| ## GET and POST Response Body An array of notification objects. Each object contains the following fields: | Property | Type | Description | | --------------------- | --------------------------------------------------- | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | | `active` | Boolean | Indicates whether the notification is being sent (`true`) or not (`false`). | | `configuration` | [WaveConfiguration[]](#analytics-notification-list) | Describes details of a Analytics notification. Only applicable when `source` is `waveNotification`. | | `createdDate` | DateTime | Date and time when the notification was created (in ISO 8601 format). | | `deactivateOnTrigger` | Boolean | Indicates whether the notification is deactivated after it's sent (`true`) or not (`false`). Deactivation doesn't delete the notification. The default value is `false`. | | `id` | String | Unique notification ID. | | `lastModifiedDate` | DateTime | Date and time when the notification was last modified (in ISO 8601 format). | | `name` | String | Display name of the notification. | | `recordId` | String | Unique ID of the record that the notification describes. Valid values are:
  • `reportId`
  • `lensId`
| | `runAs` | [runAs](#analytics-notification-list) | The person who runs the report in a report subscription. Report recipients see data in the emailed report that this person has access to in Salesforce. Available in API version 40.0 and later. Only appears if you have the “Subscribe to Reports: Add Recipients” user perm. | | `schedule` | [Schedule](#analytics-notification-list) | Details about the notification's schedule. | | `source` | String | Indicates the type of notification. Possible values are:
  • `lightningSubscribe` — report subscriptions
  • `lightningDashboardSubscribe` — dashboard subscriptions
  • `lightningReportSubscribe` — report subscriptions
  • `waveNotification` — Analytics notifications
| | `thresholds` | [Threshold[]](#analytics-notification-list) | Specifies what happens when the notification runs. For example, sending an email with report results. | **runAs** | Property | Type | Description | | -------- | ------ | --------------------------------------- | | `id` | String | The person’s unique Salesforce user ID. | | `name` | String | The person’s first and last name. | **Schedule** | Property | Type | Description | | --------------- | ------------------------------------------------ | -------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | | `frequency` | String | How frequently the notification is invoked. Possible values are:
  • `daily` — Every day
  • `weekly` — One or more days each week
  • `monthly` — One or more days each month
| | `frequencyType` | String | Only necessary when `frequency` is `monthly`. Possible values are:
  • `relative` — Days which can change month-to-month, as described by `details`.
  • `specific` — Fixed monthly dates, as described by `details`.
| | `details` | [ScheduleDetail[]](#analytics-notification-list) | Describes the notification schedule. Varies depending on whether `frequency` is `daily`, `weekly`, or `monthly`. | **ScheduleDetail (`frequency` is `daily`)** | Property | Type | Description | | -------- | ------- | ---------------------------------------------------------------------------------------------------- | | `time` | Integer | The hour of the day at which the notification is invoked. Possible values are integers from 0 to 23. | **ScheduleDetail (`frequency` is `weekly`)** | Property | Type | Description | | ------------ | -------- | ----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | | `time` | Integer | The hour of the day at which the notification is invoked. Possible values are integers from 0 to 23. | | `daysOfWeek` | String[] | The days of the week on which the notification is invoked. Possible values are:
  • `mon` — Monday
  • `tue` — Tuesday
  • `wed` — Wednesday
  • `thu` — Thursday
  • `fri` — Friday
  • `sat` — Saturday
  • `sun` — Sunday
| **ScheduleDetail (`frequency` is `monthly`, `frequencyType` is `relative`)** | Property | Type | Description | | ------------- | ------- | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | | `time` | Integer | The hour of the day at which the notification is invoked. Possible values are integers from 0 to 23. | | `weekInMonth` | String | The week in the month during which the notification is invoked. Possible values are:
  • `first` — First week
  • `second` — Second week
  • `third` — Third week
  • `fourth` — Fourth week
| | `dayInWeek` | String | The day of the week on which the notification is invoked. Possible values are:
  • `mon` — Monday
  • `tue` — Tuesday
  • `wed` — Wednesday
  • `thu` — Thursday
  • `fri` — Friday
  • `sat` — Saturday
  • `sun` — Sunday
  • `weekday` — Weekday
  • `weekend` — Weekend day
| **ScheduleDetail (`frequency` is `monthly`, `frequencyType` is `specific`)** | Property | Type | Description | | ------------- | --------- | ----------------------------------------------------------------------------------------------------------------------------------------------------------- | | `time` | Integer | The hour of the day at which the notification is invoked. Possible values are integers from 0 to 23. | | `daysOfMonth` | Integer[] | The days of the month on which the notification is invoked. Possible values are integers from 1 to 31, and -1 (which represents the last day of the month). | **Threshold** | Property | Type | Description | | ------------ | ------------------------------------------- | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | | `actions` | [Action[]](#analytics-notification-list) | Specifies what action is taken when the notification is invoked. | | `conditions` | [Condition[]](#analytics-notification-list) | Describes conditions that govern when the notification is invoked. | | `type` | String | Specifies when the notification is invoked (other than date and time criteria). Possible values are:
  • `always` — Always invoke the notification
  • `onError` — Invoke the notification when there is an error
  • `condition` — Invoke the notification based on criteria described by `conditions`
| **Condition** | Property | Type | Description | | ----------- | ------ | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | | `colName` | String | The data field which is operated on. | | `value` | String | The comparison value which is used by the operation. | | `operation` | String | The operation which is used to evaluate the condition. Possible values are:
  • `equal` — `colName` and `value` are equal
  • `notEqual` — `colName` and `value` are not equal
  • `greaterThan` — `colName` is greater than `value`
  • `lessThan` — `colName` is less than `value`
  • `greaterThanEqual` — `colName` is greater than or equal to `value`
  • `lessThanEqual` — `colName` is less than or equal to `value`
[...]
